/*****************************************************************************/
/*
                                PostMail.c

A CGI-compliant script.

25-SEP-96 MGD NOTE; would love to (re)design/rewrite this at some stage, it's
atrocious to the point of embarressment  :^(

The HTTP GET method is used to obtain the fill-out form for submitting a 
message. 

The HTTP POST method is used to submit that form's fields for mailing.  All 
information is retrieved form the "application/x-www-form-urlencoded" contents 
of the request body via the HTTP$INPUT stream available to the POST script 
(this program). 

Form field names are included in the message as underlined (with hyphens)
headings, unless the field name is "HIDDEN", in which case it is not included. 
Following each field name is the field value.

The AUTHENTICATED originating user name is obtained from the "WWW_REMOTE_USER" 
CGI variable which in turn must be verified from SYSUAF authentication.

Non-authenticated messages can be sent.  An explanation is prefixed to the
message explaining the user may be who they say they are.

The message is posted via the VMS callable mail interface.  One kludge is 
necessary to make the message appear to originate from the authenticated 
remote user.  The callable mail interface allows alteration of the "From:" 
header using SYSPRV.  Unfortunately (and annoyingly) this does not seem to 
propagate via mail transports (e.g. "MX%"), these seem to only use the 
username of the originating process.  This utility sets the originating 
process' username to that of the authenticated remote username using a short 
piece of kernel-mode macro (plagiarized from the "BECOME" utility) called 
before the mail interface is invoked.  It is necessary to reset the username 
to the original after completion as this (certainly unsupported) mechanism 
seems to change the process header of the parent, not script subprocess. 

The form fields have a role in both the GET of the mail form and the POST of
the message mailing.  In the former the field contents specifiy the defaults of
the form fields.  Setting the 'fixed' field to "yes" causes all supplied fields
to be fixed (i.e. unchangeable).  In the latter (POST) the form fields of
course provide the details for mailing the message.


FORM FIELDS
-----------
body=           body of message (or via 'message')
cc=             courtesy copy address(es), or sender if "(self)" specified
deform=         like "mailto", but data stream is escaped and de-"<form>"ed
fixed=          if non-null makes supplied text in mail form unalterable
help=           if non-null cause a redirection header to the help URL
list=           URL format specification for distribution list file
mailto=         the rest of the POST data stream is the unescaped message body
message=        URL format specification for the message file (or via 'body')
sc=             if non-null prevents message delivery (i.e. safety catch)
sender=         the user-supplied e-mail address of a non-authenticated user
sender_name=    the user-supplied personal name of a non-authenticated user
subject=        synopsis of message
textarea=       specifies the colums and rows of the body field (CCxRR)
to=             destination address(es) (if '*' and 'list' then all of list)


QUALIFIERS
----------
/[NO]AUTH       authenticate (default) VMS username, /NOAUTH nonauthenticated
/DBUG           turns on all "if (Debug)" statements
/ICON=          URL of utility icon (optional)
/SMTP=          SMTP transport (e.g. "MX", "IN")


INSTALL DETAILS
---------------
INSTALL ADD directory:POSTMAIL.EXE /PRIVILEGE=CMKRNL


BUILD DETAILS
-------------
See BUILD_POSTMAIL.COM procedure.


VERSION HISTORY (update SoftwareID as well!)
---------------
21-JUL-97  MGD  v1.6.0, post HTTPd v4.3, only request body in POSTed message
24-SEP-96  MGD  v1.5.0, if form field name is "hidden" not included in body;
                        allow for newlines in parse of "to:" and "cc:" fields;
                        some funnies around mail$send_message()!
16-MAY-96  MGD  v1.4.0, added "non-authenticated" mail
24-APR-96  MGD  v1.3.1, minor change to "deformed" layout
16-APR-96  MGD  v1.3.0, added CC (courtesy-copy) option
21-NOV-95  MGD  v1.2.0, changed reporting in PostAddAddress() to incorporate
                        MAIL signalled messages, for more extensive information
24-MAY-95  MGD  v1.1.0, minor changes for AXP compatibility
03-APR-95  MGD  v1.0.0, initial development
*/
/*****************************************************************************/

#ifdef __ALPHA
   char SoftwareID [] = "POSTMAIL AXP-1.6.0";
#else
   char SoftwareID [] = "POSTMAIL VAX-1.6.0";
#endif

/* standard C header files */
#include <stdio.h>
#include <ctype.h>
#include <errno.h>
#include <unixio.h>

/* VMS-related header files */
#include <descrip.h>
#include <jpidef.h>
#include <libdef.h>
#include <maildef.h>
#include <mail$routines.h>
#include <prvdef.h>
#include <rms.h>
#include <ssdef.h>
#include <stsdef.h>

#ifdef __ALPHA
#   pragma nomember_alignment
#endif

#define boolean int
#define true 1
#define false 0

#define VMSok(x) ((x) & STS$M_SUCCESS)
#define VMSnok(x) (!((x) & STS$M_SUCCESS))
 
#define HttpBufferSize 4096
#define CgiFormBodySize 16384

#define CcSelf "(SELF)"

char  Http200Header [] =
"HTTP/1.0 200 Document follows.\r\n\
Content-Type: text/html\r\n\
\r\n";

char  Http302Header [] =
"HTTP/1.0 302 Redirection.\r\n\
Location: http://%s:%s%s\r\n\
\r\n";

char  Http404Header [] =
"HTTP/1.0 404 Error report follows.\r\n\
Content-Type: text/html\r\n\
\r\n";

char  ErrorStringSize [] = "String size too small.";

char  Utility [] = "POSTMAIL";

struct AnExitHandler
{
   unsigned long  Flink;
   unsigned long  HandlerAddress;
   unsigned long  ArgCount;
   unsigned long  ExitStatus;
};

boolean  Debug,
         AuthenticatedSender,
         CourtesyCopy,
         HttpHasBeenOutput;

int  ContentCount,
     ContentLength,
     ExitStatus,
     SendFailedCount,
     SendOkCount;
     
char  CgiContentLength [16],
      CgiContentType [256],
      CgiRequestMethod [16],
      CgiRemoteHost [128],
      CgiRemoteUser [13],
      CgiScriptName [256],
      CgiServerName [128],
      CgiServerPort [128],
      CgiFormBody [CgiFormBodySize],
      CgiFormFixed [16],
      CgiFormHelp [16],
      CgiFormList [256],
      CgiFormMessage [256],
      CgiFormSender [256],
      CgiFormSenderName [256],
      CgiFormSubject [256],
      CgiFormSafetyCatch [16],
      CgiFormTo [1024],
      CgiFormCc [1024],
      CgiFormTextArea [16],
      HelpUrl [256],
      Icon [256],
      IconImage [256],
      JpiUserName [13],
      MailUserName [256],
      PaddedJpiUserName [13],
      SenderName [256],
      SmtpTransport [256];

FILE  *HttpIn,
      *HttpOut;

char* CopyToHtml (char*, char*, int);

struct AnExitHandler  ExitHandler;

/********************************/
/* required function prototypes */
/********************************/

int GetHttpString (char, char*, int, boolean);
extern int SetUserName (char*);
ExitViaTelephoneBooth ();
char* MapUrl (char*, char*, char*, char*);
SendErrorRoutine ();
SendSuccessRoutine ();

/*****************************************************************************/
/*
*/

main (int argc, char *argv[])

{
   register int  acnt;
   register char  *cptr, *sptr;

   int  status;
   char  String [256];

   /*********/
   /* begin */
   /*********/

   if (getenv ("POSTMAIL$DBUG") != NULL)
   {
      Debug = true;
      system ("SHOW SYM WWW_*");
   }

   /* open another output stream so that the "\n" are not filtered */
#ifdef __DECC
   if ((HttpOut = fopen ("SYS$OUTPUT", "w", "ctx=bin")) == NULL)
      exit (vaxc$errno);
#else
   if ((HttpOut = fopen ("SYS$OUTPUT", "w", "rfm=udf")) == NULL)
      exit (vaxc$errno);
#endif

   /***********************************/
   /* get the command line parameters */
   /***********************************/

   /* using this mechanism parameters must be space-separated! */
   for (acnt = 1; acnt < argc; acnt++)
   {
      if (Debug) fprintf (stdout, "argv[%d] |%s|\n", acnt, argv[acnt]);
      if (strsame (argv[acnt], "/DBUG", -1))
      {
         Debug = true;
         continue;
      }
      if (strsame (argv[acnt], "/HELP=", 5))
      {
         for (cptr = argv[acnt]+5; *cptr && *cptr != '='; cptr++);
         if (*cptr) cptr++;
         sptr = HelpUrl;
         while (*cptr) *sptr++ = *cptr++;
         *sptr = '\0';
         continue;
      }
      if (strsame (argv[acnt], "/ICON=", 5))
      {
         for (cptr = argv[acnt]+5; *cptr && *cptr != '='; cptr++);
         if (*cptr) cptr++;
         sptr = Icon;
         while (*cptr) *sptr++ = *cptr++;
         *sptr = '\0';
         sprintf (IconImage, "<IMG ALIGN=bottom SRC=\"%s\" ALT=\"\"> ", Icon);
         continue;
      }
      if (strsame (argv[acnt], "/AUTH", -1))
      {
         AuthenticatedSender = true;
         continue;
      }
      if (strsame (argv[acnt], "/NOAUTH", -1))
      {
         AuthenticatedSender = false;
         continue;
      }
      if (strsame (argv[acnt], "/SMTP=", 5))
      {
         for (cptr = argv[acnt]+5; *cptr && *cptr != '='; cptr++);
         if (*cptr) cptr++;
         sptr = SmtpTransport;
         while (*cptr) *sptr++ = toupper(*cptr++);
         *sptr = '\0';
         continue;
      }
      fprintf (stdout, "%%%s-E-IVQUAL, unrecognized qualifier\n \\%s\\\n",
               Utility, argv[acnt]+1);
      exit (STS$K_ERROR | STS$M_INHIB_MSG);
   }

   GetJpiUserName ();

   /*****************************/
   /* get general CGI variables */
   /*****************************/

   GetCgiVariable ("WWW_REMOTE_USER", CgiRemoteUser, sizeof(CgiRemoteUser));
   GetCgiVariable ("WWW_REMOTE_HOST", CgiRemoteHost, sizeof(CgiRemoteHost));
   GetCgiVariable ("WWW_REQUEST_METHOD", CgiRequestMethod,
                   sizeof(CgiRequestMethod));

   /* numeric equivalent of "GET\0" (just a bit more efficient, that's all!) */
   if (*(unsigned long*)CgiRequestMethod == 0x00544547)
   {
      /**************/
      /* GET method */
      /**************/

      /* get method specific CGI variables */
      GetCgiVariable ("WWW_SCRIPT_NAME", CgiScriptName, sizeof(CgiScriptName));
      GetCgiVariable ("WWW_FORM_BODY", CgiFormBody, sizeof(CgiFormBody));
      GetCgiVariable ("WWW_FORM_FIXED", CgiFormFixed, sizeof(CgiFormFixed));
      GetCgiVariable ("WWW_FORM_HELP", CgiFormHelp, sizeof(CgiFormHelp));
      GetCgiVariable ("WWW_FORM_LIST", CgiFormList, sizeof(CgiFormList));
      GetCgiVariable ("WWW_FORM_MESSAGE", CgiFormMessage, sizeof(CgiFormMessage));
      GetCgiVariable ("WWW_FORM_TEXTAREA", CgiFormTextArea, sizeof(CgiFormTextArea));
      GetCgiVariable ("WWW_FORM_SC", CgiFormSafetyCatch, sizeof(CgiFormSafetyCatch));
      GetCgiVariable ("WWW_FORM_TO", CgiFormTo, sizeof(CgiFormTo));
      if (GetCgiVariable ("WWW_FORM_CC", CgiFormCc, sizeof(CgiFormCc)))
         CourtesyCopy = true;
      else
         CourtesyCopy = false;
      GetCgiVariable ("WWW_FORM_SUBJECT", CgiFormSubject, sizeof(CgiFormSubject));

      if (CgiFormHelp[0])
      {
         GetCgiVariable ("WWW_SERVER_NAME", CgiServerName,
                         sizeof(CgiServerName));
         GetCgiVariable ("WWW_SERVER_PORT", CgiServerPort,
                         sizeof(CgiServerPort));
         fprintf (HttpOut, Http302Header,
                  CgiServerName, CgiServerPort, HelpUrl);
         exit (SS$_NORMAL);
      }

      MessageForm ();

      exit (SS$_NORMAL);
   }

   /***************/
   /* POST method */
   /***************/

   /* numeric equivalent of "POST" (just a bit more efficient, that's all!) */
   if (*(unsigned long*)CgiRequestMethod != 0x54534F50) exit (SS$_NORMAL);

   /* get method specific CGI variables */
   GetCgiVariable ("WWW_CONTENT_LENGTH", CgiContentLength,
                   sizeof(CgiContentLength));
   GetCgiVariable ("WWW_CONTENT_TYPE", CgiContentType, sizeof(CgiContentType));

   if (!strsame (CgiContentType, "application/x-www-form-urlencoded", -1) &&
       !strsame (CgiContentType, "text/plain", -1))
   {
      sprintf (String, "POST Content-Type: \"<TT>%s</TT>\" not supported.",
               CgiContentType);
      ErrorGeneral (String, __FILE__, __LINE__);
      exit (SS$_NORMAL);
   }

   /* open the HTTP input stream */
   if ((HttpIn = fopen ("HTTP$INPUT", "r")) == NULL)
      exit (vaxc$errno);

   ContentLength = atoi (CgiContentLength);
   PostProcessBody ();

   PostCheckParameters ();

   PostMessage (MailUserName, CgiFormSender, CgiFormSenderName,
                CgiFormTo, CgiFormCc, CgiFormSubject,
                CgiFormBody, CgiFormList, CgiFormMessage);

   exit (SS$_NORMAL);
}

/*****************************************************************************/
/*
Generate an HTML form to accept a mail message.  This function is called when 
using the HTTP GET method.
*/ 

MessageForm ()

{
   register int  cnt;
   register char  *cptr, *sptr;

   int  status,
        CharCount,
        Cols,
        Rows,
        SelectorSize;
   char  HtmlSubject [256],
         HtmlBody [4096],
         HtmlString [1024],
         HtmlTo [256],
         ListFileName [256],
         MessageFileName [256],
         String [1024];
   char  *TitlePtr;
   FILE  *ListFile,
         *MessageFile;
         
   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "MessageForm()\n");

   if (AuthenticatedSender)
   {
      /* if remote user name is not present (not authenticated) then fail */
      if (!CgiRemoteUser[0])
      {
         ErrorAuthentication (__FILE__, __LINE__);
         exit (SS$_NORMAL);
      }
      strcpy (MailUserName, CgiRemoteUser);
   }
   else
      strcpy (MailUserName, JpiUserName);

   if (CgiFormMessage[0])
   {
      /****************/
      /* message file */
      /****************/

      sptr = MapUrl (CgiFormMessage, MessageFileName, NULL, NULL);
      if (!*sptr)
      {
         ErrorGeneral (sptr+1, __FILE__, __LINE__);
         exit (SS$_NORMAL);
      }

      if ((MessageFile = fopen (MessageFileName, "r")) == NULL)
      {
         status = vaxc$errno;
         ErrorVmsStatus (status, CgiFormMessage, MessageFileName,
                         __FILE__, __LINE__);
         exit (SS$_NORMAL);
      }
   }

   if (CgiFormList[0])
   {
      /*********************/
      /* distribution list */
      /*********************/

      sptr = MapUrl (CgiFormList, ListFileName, NULL, NULL);
      if (!*sptr)
      {
         ErrorGeneral (sptr+1, __FILE__, __LINE__);
         exit (SS$_NORMAL);
      }

      if ((ListFile = fopen (ListFileName, "r")) == NULL)
      {
         status = vaxc$errno;
         ErrorVmsStatus (status, CgiFormList, ListFileName,
                         __FILE__, __LINE__);
         exit (SS$_NORMAL);
      }

      /* count the number of lines containing legitimate strings */
      SelectorSize = 0;
      while (fgets (String, sizeof(String), ListFile) != NULL)
      {
         for (cptr = String; isspace(*cptr); cptr++);
         if (!isprint(*cptr)) continue;
         sptr = cptr;
         while (*cptr && !isspace(*cptr) && isprint(*cptr)) cptr++;
         if (cptr == sptr) continue;
         if (++SelectorSize >= 5) break;
      }
      if (!SelectorSize)
      {
         fclose (ListFile);
         sprintf (String, "Empty distribution list: <TT>%s</TT>. <!-- %s -->",
                  CgiFormList, ListFileName);
         ErrorGeneral (String, __FILE__, __LINE__);
         exit (SS$_NORMAL);
      }
      rewind (ListFile);
   }

   /********************************/
   /* html title, from field, etc. */
   /********************************/

   if (AuthenticatedSender)
      TitlePtr = "Post Mail Message (authenticated)";
   else
      TitlePtr = "Send Mail Message (non-authenticated)";

   fprintf (HttpOut,
"%s\
<HTML>\n\
<!-- SoftwareID: %s -->\n\
<TITLE>%s</TITLE>\n\
<H1>%s%s</H1>\n\
<P><HR>\n\
<FORM METHOD=POST ACTION=\"%s\">\n",
   Http200Header, SoftwareID, TitlePtr, IconImage, TitlePtr, CgiScriptName);
   HttpHasBeenOutput = true;

   if (AuthenticatedSender)
      fprintf (HttpOut, "<P>From: <TT>%s</TT>\n", MailUserName);
   else
   {
      fprintf (HttpOut,
"<P>From: <INPUT NAME=sender TYPE=text SIZE=40> <I>(e-mail address)</I>\n\
<BR>Name: <INPUT NAME=sender_name TYPE=text SIZE=25> <I>(optional)</I>\n");
   }

   if (CgiFormList[0])
      fprintf (HttpOut, "<INPUT NAME=list TYPE=hidden VALUE=\"%s\">\n",
               CgiFormList);

   /************/
   /* to field */
   /************/

   if (CgiFormFixed[0] && CgiFormList[0] && CgiFormTo[0] == '*')
   {
      /* unalterable, all members of a distribution list */
      fputs ("<P>To: <TT>", HttpOut);
      CharCount = cnt = 0;
      while (fgets (String, sizeof(String), ListFile) != NULL)
      {
         for (cptr = String; isspace(*cptr); cptr++);
         if (!isprint(*cptr)) continue;
         sptr = cptr;
         while (*cptr && !isspace(*cptr) && isprint(*cptr)) cptr++;
         if (cptr == sptr) continue;
         *cptr = '\0';
         CopyToHtml (HtmlTo, sptr, sizeof(HtmlTo));
         if (CharCount >= 55)
         {
            fputs (",\n", HttpOut);
            CharCount = 0;
         }
         if (!cnt++ || !CharCount)
            CharCount += fprintf (HttpOut, "%s", HtmlTo);
         else
            CharCount += fprintf (HttpOut, ",%s", HtmlTo);
      }
      fclose (ListFile);
      fprintf (HttpOut, "</TT>\n<INPUT NAME=to TYPE=hidden VALUE=\"%s\">\n",
               CgiFormTo);
   }
   else
   if (CgiFormList[0] && CgiFormTo[0] == '*')
   {
      /* all members of a distribution list in a field */
      fputs ("<P>To: <INPUT NAME=to TYPE=text SIZE=48 MAXIMUM=4096 VALUE=\"",
             HttpOut);
      cnt = 0;
      while (fgets (String, sizeof(String), ListFile) != NULL)
      {
         for (cptr = String; isspace(*cptr); cptr++);
         if (!isprint(*cptr)) continue;
         sptr = cptr;
         while (*cptr && !isspace(*cptr) && isprint(*cptr)) cptr++;
         if (cptr == sptr) continue;
         *cptr = '\0';
         CopyToHtml (HtmlTo, sptr, sizeof(HtmlTo));
         if (!cnt++)
            fputs (HtmlTo, HttpOut);
         else
            fprintf (HttpOut, ",%s", HtmlTo);
      }
      fclose (ListFile);
      fputs ("\">\n", HttpOut);
   }
   else
   if (CgiFormFixed[0] && CgiFormTo[0])
   {
      /* unalterable destination */
      CopyToHtml (HtmlTo, CgiFormTo, sizeof(HtmlTo));
      fprintf (HttpOut,
"<P>To: <TT>%s</TT>\n\
<INPUT NAME=to TYPE=hidden VALUE=\"%s\">\n",
      HtmlTo, CgiFormTo);
   }
   else
   if (CgiFormList[0])
   {
      /* select one (or all) members of a distribution list */
      fprintf (HttpOut,
"<P>To:\n<SELECT NAME=to SIZE=%d>\n\
<OPTION VALUE=\"*\" SELECTED>\"all on list\"\n",
      SelectorSize);
      while (fgets (String, sizeof(String), ListFile) != NULL)
      {
         for (cptr = String; isspace(*cptr); cptr++);
         if (!isprint(*cptr)) continue;
         sptr = cptr;
         while (*cptr && !isspace(*cptr) && isprint(*cptr)) cptr++;
         if (cptr == sptr) continue;
         *cptr = '\0';
         CopyToHtml (HtmlTo, sptr, sizeof(HtmlTo));
         fprintf (HttpOut, "<OPTION VALUE=\"%s\">%s\n", sptr, HtmlTo);
      }
      fclose (ListFile);
      fputs ("</SELECT>\n", HttpOut);
   }
   else
   {
      /* field to allow entry of destination address(es) */
      fprintf (HttpOut,
"<P>To: <INPUT NAME=to TYPE=text SIZE=48 MAXIMUM=255 VALUE=\"%s\">\n",
      CgiFormTo);
   }

   /************/
   /* cc field */
   /************/

   if (CourtesyCopy)
   {
      if (AuthenticatedSender && strsame (CgiFormCc, CcSelf, -1))
      {
         /* courtesy copy to back sender */
         strcpy (CgiFormCc, MailUserName);
         CopyToHtml (HtmlTo, CgiFormCc, sizeof(HtmlTo));
         fprintf (HttpOut,
"<P>CC: <TT>%s</TT>\n\
<INPUT NAME=cc TYPE=hidden VALUE=\"%s\">\n",
         HtmlTo, CgiFormCc);
      }
      else
      if (CgiFormFixed[0] && CgiFormCc[0])
      {
         /* unalterable destination */
         CopyToHtml (HtmlTo, CgiFormCc, sizeof(HtmlTo));
         fprintf (HttpOut,
"<P>CC: <TT>%s</TT>\n\
<INPUT NAME=to TYPE=hidden VALUE=\"%s\">\n",
         HtmlTo, CgiFormCc);
      }
      else
      {
         /* field to allow entry of destination address(es) */
         fprintf (HttpOut,
"<P>CC: <INPUT NAME=cc TYPE=text SIZE=48 MAXIMUM=255 VALUE=\"%s\">\n",
         CgiFormCc);
      }
   }

   /*****************/
   /* subject field */
   /*****************/

   if (CgiFormFixed[0] && CgiFormSubject[0])
   {
      /* unalterable subject */
      CopyToHtml (HtmlSubject, CgiFormSubject, sizeof(HtmlSubject));
      /* "hidden" fields don't seem capable of handling quotes in any form! */
      for (cptr = CgiFormSubject; *cptr; cptr++)
         if (*cptr == '\"') *cptr = '\'';
      fprintf (HttpOut,
"<P>Subject: <TT>%s</TT>\n\
<INPUT NAME=subject TYPE=hidden VALUE=\"%s\">\n",
      HtmlSubject, CgiFormSubject);
   }
   else
   {
      /* field to allow entry of subject */
      fprintf (HttpOut,
"<P>Subject: <INPUT NAME=subject TYPE=text SIZE=48 MAXIMUM=255 VALUE=\"%s\">\n",
      CgiFormSubject);
   }

   /*************/
   /* text area */
   /*************/

   if (CgiFormTextArea[0])
   {
      Cols = atoi(CgiFormTextArea);
      Rows = atoi(CgiFormTextArea+3);
   }
   else
      Cols = Rows = 0;
   if (!Cols) Cols = 64;
   if (!Rows) Rows = 8;
   if (Cols > 80)
      Cols = 80;
   else
   if (Cols < 40)
      Cols = 40;
   if (Rows > 64)
      Cols = 64;
   else
   if (Rows < 4)
      Cols = 4;

   if (CgiFormFixed[0] && CgiFormMessage[0]) 
   {
      /* message contents from file as fixed message body  */
      fputs ("<P>Message:\n<P><BLOCKQUOTE><PRE>", HttpOut);
      while (fgets (String, sizeof(String)-3, MessageFile) != NULL)
      {
         /* change newline to cr/lf carriage control */
         for (cptr = String; *cptr && *cptr != '\n'; cptr++);
         *cptr++ = '\r';
         *cptr++ = '\n';
         *cptr = '\0';
         CopyToHtml (HtmlString, String, sizeof(HtmlString));
         fputs (HtmlString, HttpOut);
      }
      fclose (MessageFile);
      fprintf (HttpOut,
"</PRE></BLOCKQUOTE>\n\
<INPUT NAME=message TYPE=hidden VALUE=\"%s\">\n",
      CgiFormMessage);
   }
   else
   if (CgiFormMessage[0]) 
   {
      /* message contents from file into text area */
      fprintf (HttpOut, "<P><TEXTAREA NAME=body ROWS=%d COLS=%d>",
               Rows, Cols);
      while (fgets (String, sizeof(String)-3, MessageFile) != NULL)
      {
         /* change newline to cr/lf carriage control */
         for (cptr = String; *cptr && *cptr != '\n'; cptr++);
         *cptr++ = '\r';
         *cptr++ = '\n';
         *cptr = '\0';
         CopyToHtml (HtmlString, String, sizeof(HtmlString));
         fputs (HtmlString, HttpOut);
      }
      fclose (MessageFile);
      fputs ("</TEXTAREA>\n", HttpOut);
   }
   else
   if (CgiFormFixed[0] && CgiFormBody[0]) 
   {
      /* unalterable message text */
      CopyToHtml (HtmlBody, CgiFormBody, sizeof(HtmlBody));
      /* "hidden" fields don't seem capable of handling quotes in any form! */
      for (cptr = CgiFormBody; *cptr; cptr++)
         if (*cptr == '\"') *cptr = '\'';
      fprintf (HttpOut,
"<P>Message:\n<P><BLOCKQUOTE><PRE>%s</PRE></BLOCKQUOTE>\n\
<INPUT NAME=body TYPE=hidden VALUE=\"%s\">\n",
      HtmlBody, CgiFormBody);
   }
   else
   {
      /* field to allow entry of message text */
      fprintf (HttpOut,
"<P><TEXTAREA NAME=body ROWS=%d COLS=%d>%s</TEXTAREA>\n",
      Rows, Cols, CgiFormBody);
   }

   /***********************/
   /* submit button, etc. */
   /***********************/

   fputs (
"<P><INPUT TYPE=submit VALUE=\" send \">\n\
(<B>to cancel</B> this message use your browser to <B>navigate backwards</B>)\n\
<INPUT TYPE=reset VALUE=\" reset \">\n",
   HttpOut);

   if (CgiFormSafetyCatch[0])
      fputs (
"<BR><I>( safety-catch <INPUT TYPE=checkbox NAME=sc VALUE=\"on\" CHECKED>)</I>\n",
      HttpOut);

   fputs ("</FORM>\n<P><HR>\n", HttpOut);

   if (!(CgiFormTextArea[0] || (CgiFormFixed[0] && (CgiFormBody[0] || CgiFormMessage[0]))))
   {
      /*********************************/
      /* form to change text area size */
      /*********************************/

      fprintf (HttpOut, "<FORM ACTION=\"%s\">\n", CgiScriptName);

      if (CgiFormList[0])
         fprintf (HttpOut, "<INPUT TYPE=hidden NAME=list VALUE=\"%s\">\n",
                  CgiFormList);

      if (CgiFormMessage[0])
         fprintf (HttpOut, "<INPUT TYPE=hidden NAME=message VALUE=\"%s\">\n",
                  CgiFormMessage);

      if (CgiFormTo[0])
         fprintf (HttpOut, "<INPUT TYPE=hidden NAME=to VALUE=\"%s\">\n",
                  CgiFormTo);

      if (CgiFormSubject[0])
         fprintf (HttpOut, "<INPUT TYPE=hidden NAME=subject VALUE=\"%s\">\n",
                  CgiFormSubject); 

      if (CgiFormBody[0])
         fprintf (HttpOut, "<INPUT TYPE=hidden NAME=body VALUE=\"%s\">\n",
                  CgiFormBody);

      if (CgiFormFixed[0])
         fprintf (HttpOut,
                  "<INPUT TYPE=hidden NAME=fixed VALUE=\"%s\">\n",
                  CgiFormFixed);

      fputs (
"<INPUT TYPE=submit VALUE=\" change \">\n\
<I>Changing text area size does not propagate any altered fields!</I>\n\
<SELECT NAME=TextArea>\n\
<OPTION VALUE=\"80x24\" SELECTED>80 x 24\n\
<OPTION VALUE=\"80x12\">80 x 12\n\
<OPTION VALUE=\"80x6\">80 x 6\n\
<OPTION VALUE=\"64x24\">64 x 24\n\
<OPTION VALUE=\"64x12\">64 x 12\n\
<OPTION VALUE=\"64x6\">64 x 6\n\
<OPTION VALUE=\"40x24\">40 x 24\n\
<OPTION VALUE=\"40x12\">40 x 12\n\
<OPTION VALUE=\"40x6\">40 x 6\n\
</SELECT>\n\
</FORM>\n",
      HttpOut);
   }

   if (HelpUrl[0])
   {
      /*************/
      /* help form */
      /*************/

      fprintf (HttpOut,
"<FORM ACTION=\"%s\">\n\
<INPUT TYPE=submit VALUE=\" H E L P \">\n\
</FORM>\n",
      HelpUrl);
   }

   fputs ("<HTML>\n", HttpOut);
}

/*****************************************************************************/
/*
The process body should be a URL-format string, possibly broken into multiple 
lines.  Read that string getting the URL-encoded form keywords and the 
associated values.
*/ 

PostProcessBody (char *HttpBufferPtr)

{
   register int  len;

   int  status;
   char  Field [256],
         String [256];

   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "PostProcessBody()\n");

   ContentCount = 0;
   while (ContentCount < ContentLength)
   {
      String[0] = '\0';
      if (GetHttpString ('=', Field, sizeof(Field), true) == sizeof(Field))
      {
         sprintf (String, "The field names can be %d characters maximum.",
                  sizeof(Field)-1);
         ErrorGeneral (String, __FILE__, __LINE__);
         exit (SS$_NORMAL);
      }

      if (strsame (Field, "body", -1))
      {
         len = GetHttpString ('&', CgiFormBody, sizeof(CgiFormBody), true);
         if (len == sizeof(CgiFormBody))
         {
            sprintf (String,
            "The body of a message can be %d characters maximum.",
            sizeof(CgiFormBody)-1);
         }
      }
      else
      if (strsame (Field, "cc", -1))
      {
         len = GetHttpString ('&', CgiFormCc, sizeof(CgiFormCc), true);
         if (len == sizeof(CgiFormCc))
         {
            sprintf (String,
            "The courtesy copy address(es) can be %d characters maximum.",
            sizeof(CgiFormCc)-1);
         }
      }
      else
      if (strsame (Field, "deform", -1))
      {
         DeformBody ();
         return;
      }
      else
      if (strsame (Field, "list", -1))
         len = GetHttpString ('&', CgiFormList, sizeof(CgiFormList), true);
      else
      if (strsame (Field, "mailto", -1))
      {
         /* do not URL-escape this data stream */
         len = GetHttpString ('\0', CgiFormBody, sizeof(CgiFormBody), false);
         if (len == sizeof(CgiFormBody))
         {
            sprintf (String,
            "The body of a message can be %d characters maximum.",
            sizeof(CgiFormBody)-1);
         }
      }
      else
      if (strsame (Field, "message", -1))
         len = GetHttpString ('&', CgiFormMessage, sizeof(CgiFormMessage), true);
      else
      if (strsame (Field, "sender", -1))
         len = GetHttpString ('&', CgiFormSender, sizeof(CgiFormSender), true);
      else
      if (strsame (Field, "sender_name", -1))
         len = GetHttpString ('&', CgiFormSenderName, sizeof(CgiFormSenderName), true);
      else
      if (strsame (Field, "subject", -1))
      {
         len = GetHttpString ('&', CgiFormSubject, sizeof(CgiFormSubject), true);
         if (len == sizeof(CgiFormSubject))
         {
            sprintf (String,
            "The subject can be %d characters maximum.",
            sizeof(CgiFormSubject)-1);
         }
      }
      else
      if (strsame (Field, "sc", -1))
         len = GetHttpString ('&', CgiFormSafetyCatch, sizeof(CgiFormSafetyCatch),
                              true);
      else
      if (strsame (Field, "to", -1))
      {
         len = GetHttpString ('&', CgiFormTo, sizeof(CgiFormTo), true);
         if (len == sizeof(CgiFormTo))
         {
            sprintf (String,
            "The destination address(es) can be %d characters maximum.",
            sizeof(CgiFormTo)-1);
         }
      }
      else
         sprintf (String, "Unknown form field: \"<TT>%128.128s</TT>\".", Field);

      if (len < 0) strcpy (String, "HTTP stream terminated unexpectedly.");

      if (String[0])
      {
         ErrorGeneral (String, __FILE__, __LINE__);
         exit (SS$_NORMAL);
      }
   }
}

/*****************************************************************************/
/*
Gets the rest of the HTTP POST data stream, creating a plain text version of 
URL-enconded form data.  The plain text version comprises the field name 
followed by a newline, and form field value followed by a newline.  Muliply 
form name/value pairs are separated by blank (empty) lines.  If the value is 
empty then the field name is immediately followed by a blank line.  A non-
empty value may be a single string, etc., or a series of lines as might be 
returned by a <TEXTAREA> form element.  All value lines are prefixed by a 
single equal symbol (=), allowing blank form lines to be differentiated from 
the blank lines separating multiple form field name/values.
*/ 

DeformBody ()

{
   register int  cnt;
   register char  *cptr, *iptr, *sptr, *zptr;

   int  status;
   char  FieldName [256],
         FieldValue [4096],
         String [256],
         ValueIndent [256];

   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "DeformBody()\n");

   /* get the value of the "deform=" field, used to indent value */
   if (GetHttpString ('&', ValueIndent, sizeof(ValueIndent), true)
       == sizeof(ValueIndent))
   {
      sprintf (String, "The field values can be %d characters maximum.",
               sizeof(ValueIndent)-1);
      ErrorGeneral (String, __FILE__, __LINE__);
      exit (SS$_NORMAL);
   }

   zptr = (sptr = CgiFormBody) + sizeof(CgiFormBody);
   while (ContentCount < ContentLength && sptr < zptr)
   {
      /* get the next field name from HTTP stream */
      if (GetHttpString ('=', FieldName, sizeof(FieldName), true)
         == sizeof(FieldName))
      {
         sprintf (String, "The field names can be %d characters maximum.",
                  sizeof(FieldName)-1);
         ErrorGeneral (String, __FILE__, __LINE__);
         exit (SS$_NORMAL);
      }

      /* get the corresponding field value from HTTP stream */
      if (GetHttpString ('&', FieldValue, sizeof(FieldValue), true)
          == sizeof(FieldValue))
      {
         sprintf (String, "The field values can be %d characters maximum.",
                  sizeof(FieldValue)-1);
         ErrorGeneral (String, __FILE__, __LINE__);
         exit (SS$_NORMAL);
      }

      if (sptr > CgiFormBody && sptr < zptr)
      {
         /* i.e. not the first form name to be placed in the body */
         if (sptr > CgiFormBody)
         {
            /* if the previous field value ended in a blank line */
            if (sptr[-1] == '\n')
            {
               /* remove it, no use for trailing blank lines! */
               sptr--;
            }
         }
         /* newline after previous, separate next name by a blank line */
         if (sptr < zptr) *sptr++ = '\n';
         if (sptr < zptr) *sptr++ = '\n';
      }

      if (!strsame (FieldName, "HIDDEN", -1))
      {
         /******************************/
         /* field name is not "HIDDEN" */
         /******************************/

         /* place the field name into the message body */
         cnt = 0;
         for (cptr = FieldName; *cptr && sptr < zptr; cptr++)
         {
            if (cptr == FieldName) *cptr = toupper(*cptr);
            if (cptr > FieldName)
               if (cptr[-1] == ' ')
                  *cptr = toupper(*cptr);
            *sptr++ = *cptr;
            cnt++;
         }
         if (sptr < zptr) *sptr++ = '\n';

         while (cnt-- && sptr < zptr) *sptr++ = '-';
         if (sptr < zptr) *sptr++ = '\n';
      }

      /* place the field value into the message body */
      cptr = FieldValue;
      while (*cptr && sptr < zptr)
      {
         for (iptr = ValueIndent; *iptr && sptr < zptr; *sptr++ = *iptr++) 
         while (*cptr && *cptr != '\n' && sptr < zptr) *sptr++ = *cptr++;
         if (*cptr && sptr < zptr)
            *sptr++ = *cptr++;
         else
         if (sptr < zptr)
            *sptr++ = '\n';
      }
   }

   if (sptr >= zptr)
   {
      sprintf (String,
         "The <I>deformed</I> message body can be %d characters maximum.",
         sizeof(CgiFormBody)-1);
      ErrorGeneral (String, __FILE__, __LINE__);
      exit (SS$_NORMAL);
   }

   *sptr = '\0';
}

/*****************************************************************************/
/*
Check that all the REQUIRED form fields have been supplied.  Report to client 
if not.
*/ 

PostCheckParameters ()

{
   static char  Problems [] =
     "<B>The following prevented processing ...</B>\n<BR>\n";

   register char  c;
   register char  *sptr;

   char  String [1024];

   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "PostCheckParameters()\n");

   *(sptr = String) = '\0';
   if (!AuthenticatedSender && !CgiFormSender[0])
   {
      if (!String[0])
      { 
         strcpy (sptr, Problems);
         sptr += sizeof(Problems)-1;
      }
      strcpy (sptr, "<BR><I>From (sender)</I> not supplied.\n");
      while (*sptr) sptr++;
   }
   if (!CgiFormSubject[0])
   {
      if (!String[0])
      { 
         strcpy (sptr, Problems);
         sptr += sizeof(Problems)-1;
      }
      strcpy (sptr, "<BR><I>Subject</I> not supplied.\n");
      while (*sptr) sptr++;
   }
   if (!CgiFormBody[0] && !CgiFormMessage[0])
   {
      if (!String[0])
      { 
         strcpy (sptr, Problems);
         sptr += sizeof(Problems)-1;
      }
      strcpy (sptr, "<BR><I>Body</I> not supplied.\n");
      while (*sptr) sptr++;
   }
   if (!CgiFormTo[0])
   {
      if (!String[0])
      { 
         strcpy (sptr, Problems);
         sptr += sizeof(Problems)-1;
      }
      strcpy (sptr, "<BR><I>To</I> not supplied.\n");
      while (*sptr) sptr++;
   }
   if (String[0])
   {
      ErrorGeneral (String, __FILE__, __LINE__);
      exit (SS$_NORMAL);
   }
}

/*****************************************************************************/
/*
Use the VMS callable mail interface to create and send a VMS mail message.  
This is the main function called when using the HTTP POST method.  'To' can be 
a list of comma-separated addresses, or if an asterisk then the supplied list 
file is opened and all addresses available therein are used.  'Text' is a 
null-terminated string of '\n'-separated lines of plain text.
*/ 

int PostMessage
(
char *UserName,
char *Sender,
char *SenderName,
char *To,
char *Cc,
char *Subject,
char *Body,
char *ListPath,
char *MessagePath
)
{
   register char  *cptr, *sptr;

   int  status,
        MailStatus;
   unsigned long  Pid = 0,
                  SendContext = 0,
                  UserData;
   unsigned long  JpiImagPriv [2],
                  JpiAuthPriv [2];
   char  ListFileName [256],
         MessageFileName [256],
         NonAuthenticated [1024],
         OneAddress [256],
         String [1024];
   FILE  *MessageFile,
         *ListFile;

   struct {
      short int  buf_len;
      short int  item;
      char   *buf_addr;
      unsigned short  *ret_len;
   }
   BodyPartItem [] =
   {
      { 0, MAIL$_SEND_RECORD, 0, 0 },
      { 0, MAIL$_NOSIGNAL, 0, 0 },
      {0,0,0,0}
   },
   SendBeginItem [] =
   {
      { 0, MAIL$_SEND_NO_DEFAULT_TRANSPORT, 0, 0 },
      { 0, MAIL$_SEND_NO_PERS_NAME, 0, 0 },
      { 0, MAIL$_SEND_SERVER, 0, 0 },
      { 0, MAIL$_NOSIGNAL, 0, 0 },
      {0,0,0,0}
   },
   SubjectItem [] =
   {
      { 0, MAIL$_SEND_SUBJECT, Subject, 0 },
      { 0, MAIL$_NOSIGNAL, 0, 0 },
      {0,0,0,0}
   },
   NoSignalItem [] =
   {
      { 0, MAIL$_NOSIGNAL, 0, 0 },
      {0,0,0,0}
   },
   SendMessageItem [] =
   {
      { 4, MAIL$_SEND_ERROR_ENTRY, &SendErrorRoutine, 0 },
      { 4, MAIL$_SEND_SUCCESS_ENTRY, &SendSuccessRoutine, 0 },
      { 4, MAIL$_SEND_USER_DATA, &UserData, 0 },
      { 0, MAIL$_NOSIGNAL, 0, 0 },
      {0,0,0,0}
   },
   JpiItems [] =
   {
      { 8, JPI$_AUTHPRIV, JpiAuthPriv, 0 },
      { 8, JPI$_IMAGPRIV, JpiImagPriv, 0 },
      {0,0,0,0}
   },
   NullItem = {0,0,0,0};

   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "PostMessage()\n");

   if (AuthenticatedSender)
   {
      /* if remote user name is not present (not authenticated) then fail */
      if (!CgiRemoteUser[0])
      {
         ErrorAuthentication (__FILE__, __LINE__);
         exit (SS$_NORMAL);
      }

      NonAuthenticated[0] = '\0';
      strcpy (MailUserName, CgiRemoteUser);
   }
   else
   {
      if (!SenderName[0]) SenderName = Sender;

      sprintf (NonAuthenticated,
"NOTE: Non-authenticated message!\n\
      Software ID: %s\n\
      Purportedly from: \"%s\"\n\
      Originated at: %s\n\
      Reply-to: %s\n\
\n",
         SoftwareID,
         SenderName,
         CgiRemoteHost,
         Sender);

      strcpy (MailUserName, JpiUserName);
   }

   if (MessagePath[0])
   {
      /****************/
      /* message file */
      /****************/

      sptr = MapUrl (MessagePath, MessageFileName, NULL, NULL);
      if (!*sptr)
      {
         ErrorGeneral (sptr+1, __FILE__, __LINE__);
         exit (SS$_NORMAL);
      }

      if ((ListFile = fopen (MessageFileName, "r")) == NULL)
      {
         status = vaxc$errno;
         ErrorVmsStatus (status, MessagePath, MessageFileName,
                         __FILE__, __LINE__);
         exit (SS$_NORMAL);
      }
   }

   if (To[0] == '*')
   {
      /*********************/
      /* distribution list */
      /*********************/

      sptr = MapUrl (ListPath, ListFileName, NULL, NULL);
      if (!*sptr)
      {
         ErrorGeneral (sptr+1, __FILE__, __LINE__);
         exit (SS$_NORMAL);
      }

      if ((ListFile = fopen (ListFileName, "r")) == NULL)
      {
         status = vaxc$errno;
         ErrorVmsStatus (status, ListPath, ListFileName,
                         __FILE__, __LINE__);
         exit (SS$_NORMAL);
      }
   }

   /****************/
   /* start report */
   /****************/

   fprintf (HttpOut,
"Content-Type: text/html\r\n\
\r\n\
<!-- SoftwareID: %s -->\n\
<TITLE>Mailing Report</TITLE>\n\
<H1>%sMailing Report</H1>\n\
<P><HR>\n\
<BLOCKQUOTE>\n",
   SoftwareID, IconImage);
   fflush (HttpOut);
   HttpHasBeenOutput = true;

   /*****************/
   /* begin to mail */
   /*****************/

   if (AuthenticatedSender) TelephoneBooth (UserName);

   MailStatus = mail$send_begin (&SendContext, &SendBeginItem, &NullItem);
   if (Debug)
      fprintf (stdout, "mail$send_begin() %%X%08.08X\n", MailStatus);

   if (To[0] == '*')
   {
      /*********************/
      /* distribution list */
      /*********************/

      while (fgets (String, sizeof(String), ListFile) != NULL)
      {
         for (cptr = String; isspace(*cptr); cptr++);
         if (!isprint(*cptr)) continue;
         sptr = OneAddress;
         while (*cptr && *cptr != ',')
            if (isprint(*cptr) && !isspace(*cptr))
               *sptr++ = *cptr++;
            else
               cptr++;
         *sptr = '\0';
         if (*cptr) cptr++;
         if (!OneAddress[0]) continue;
         PostAddAddress (&SendContext, OneAddress, false);
      }
      fclose (ListFile);
   }
   else
   {
      /* a single, or multiple comma-separated addresses */
      cptr = To;
      while (*cptr)
      {
         sptr = OneAddress;
         while (*cptr && *cptr != ',')
            if (isprint(*cptr) && !isspace(*cptr))
               *sptr++ = *cptr++;
            else
               cptr++;
         *sptr = '\0';
         if (*cptr) cptr++;
         if (!OneAddress[0]) continue;
         PostAddAddress (&SendContext, OneAddress, false);
      }
   }

   /*****************/
   /* courtesy copy */
   /*****************/

   if (Cc[0])
   {
      /* a single, or multiple comma-separated addresses */
      cptr = Cc;
      while (*cptr)
      {
         sptr = OneAddress;
         while (*cptr && *cptr != ',')
            if (isprint(*cptr) && !isspace(*cptr))
               *sptr++ = *cptr++;
            else
               cptr++;
         *sptr = '\0';
         if (*cptr) cptr++;
         if (!OneAddress[0]) continue;
         PostAddAddress (&SendContext, OneAddress, true);
      }
   }

   /***********/
   /* subject */
   /***********/

   SubjectItem[0].buf_len = strlen(Subject);
   if (VMSok (MailStatus))
      MailStatus = mail$send_add_attribute (&SendContext, &SubjectItem,
                                            &NullItem);
   if (Debug)
      fprintf (stdout, "mail$send_add_attribute() %%X%08.08X\n", MailStatus);

   if (VMSok (MailStatus))
   {
      /*******************/
      /* body of message */
      /*******************/

      if (NonAuthenticated[0])
      {
         cptr = NonAuthenticated;
         while (*cptr && VMSok (MailStatus))
         {
            BodyPartItem[0].buf_addr = cptr;
            while (*cptr && *cptr != '\n') cptr++;
            BodyPartItem[0].buf_len = cptr - BodyPartItem[0].buf_addr;
            if (*cptr) cptr++;
            MailStatus = mail$send_add_bodypart (&SendContext, &BodyPartItem,
                                                 &NullItem);
            if (Debug)
               fprintf (stdout, "mail$send_add_bodypart() %%X%08.08X\n",
                        MailStatus);
         }
      }

      if (MessagePath[0])
      {
         /* from file */
         while (fgets (String, sizeof(String), MessageFile) != NULL)
         {
            /* trim trailing newline */
            for (cptr = String; *cptr != '\n'; cptr++);
            *cptr = '\0';
            BodyPartItem[0].buf_addr = String;
            BodyPartItem[0].buf_len = cptr - String;
            MailStatus = mail$send_add_bodypart (&SendContext, &BodyPartItem,
                                                 &NullItem);
            if (Debug)
               fprintf (stdout, "mail$send_add_bodypart() %%X%08.08X\n",
                        MailStatus);
         }
         fclose (MessageFile);
      }
      else
      {
         /* from form field */
         cptr = Body;
         while (*cptr && VMSok (MailStatus))
         {
            BodyPartItem[0].buf_addr = cptr;
            while (*cptr && *cptr != '\n' && *cptr != '\r') cptr++;
            BodyPartItem[0].buf_len = cptr - BodyPartItem[0].buf_addr;
            if (*cptr == '\r') cptr++;
            if (*cptr == '\n') cptr++;
/*
            if (Debug)
               fprintf (stdout, "buf_addr: %d buf_len: %d |%s|\n",
                        BodyPartItem[0].buf_addr, BodyPartItem[0].buf_len,
                        BodyPartItem[0].buf_addr);
*/
            MailStatus = mail$send_add_bodypart (&SendContext, &BodyPartItem,
                                                 &NullItem);
            if (Debug)
               fprintf (stdout, "mail$send_add_bodypart() %%X%08.08X\n",
                        MailStatus);
         }
      }
   }

   /****************/
   /* send message */
   /****************/

   if (!CgiFormSafetyCatch[0])
   {
      if (VMSok (MailStatus))
      {
         /*
            An access violation (%x0000000C) at this routine has indicated
            insufficient privilege when mailing to a user with forwarding
            to Pathworks mail.  Why?

            When installed with SYSPRV seems to require a null item,
            but when no SYSPRV wants a no-item zero!  Why?
         */
         if (VMSnok (status = sys$getjpiw (0, &Pid, 0, &JpiItems, 0, 0, 0)))
         {
            fprintf (stdout, "%%%s-I-WHERE, %s %d\n", Utility,
                     __FILE__, __LINE__);
            exit (status);
         }
         if (JpiAuthPriv[0] & PRV$M_SYSPRV || JpiImagPriv[0] & PRV$M_SYSPRV)
            MailStatus = mail$send_message (&SendContext, &SendMessageItem,
                                            &NullItem);
         else
            MailStatus = mail$send_message (&SendContext, &SendMessageItem, 0);
         if (Debug)
            fprintf (stdout, "mail$send_message() %%X%08.08X\n",
                     MailStatus);
      }
   }

   mail$send_end (&SendContext, 0, 0);

   if (VMSnok (MailStatus))
   {
      ErrorVmsStatus (MailStatus, "sending message", "" , __FILE__, __LINE__);
      return;
   }

   if (Debug) fprintf (stdout, "MailStatus: %%X%08.08X\n", MailStatus);

   /*******************/
   /* complete report */
   /*******************/

   fputs ("</PRE></BLOCKQUOTE>\n<P><HR>\n", HttpOut);

   if (SendOkCount == 1 && !SendFailedCount)
      fprintf (HttpOut, "<I>Successfully sent.</I>\n");
   else
   if (SendOkCount && !SendFailedCount)
      fprintf (HttpOut, "<I>%d (all) successfully sent.</I>\n", SendOkCount);
   else
   if (SendOkCount)
      fprintf (HttpOut, "<I>%d successfully sent.</I>\n", SendOkCount);

   if (!SendOkCount && SendFailedCount == 1)
      fprintf (HttpOut, "<I>Send failed.</I>");
   else
   if (!SendOkCount && SendFailedCount)
      fprintf (HttpOut, "<I>%d (all) failed.</I>\n", SendFailedCount);
   else
   if (SendFailedCount)
      fprintf (HttpOut, "<I>%d failed.</I>\n", SendFailedCount);

   if (CgiFormSafetyCatch[0])
      fputs (
"<H1>Message not actually sent !</H1>\n\
<B><I>Safety-Catch</I> is on.</B>\n",
      HttpOut);

   fputs ("</HTML>\n", HttpOut);
}

/*****************************************************************************/
/*
This is a stub!
*/ 

SendErrorRoutine ()

{
   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "SendErrorRoutine()\n");
}

/*****************************************************************************/
/*
This is a stub!
*/ 

SendSuccessRoutine ()

{
   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "SendSuccessRoutine()\n");
}

/*****************************************************************************/
/*
Using the VMS callable mail interface add a destination address to the mail 
message.  Called from PostMessage().
*/ 

int PostAddAddress
(
unsigned long  *SendContextPtr,
char *Address,
boolean CourtesyCopy
)
{
   static unsigned short  CcType = MAIL$_CC,
                          ToType = MAIL$_TO;

   register char  *cptr, *sptr;

   int  status;
   short int  Length;
   char  SelfAddress [32],
         String [512];

   struct {
      short int  buf_len;
      short int  item;
      unsigned char   *buf_addr;
      unsigned short  *ret_len;
   }  SendUserNameItem [] =
   {
      { 0, MAIL$_SEND_USERNAME, 0, 0 },
      { sizeof(unsigned short), MAIL$_SEND_USERNAME_TYPE, 0, 0 },
      {0,0,0,0}
   },
   NullItem = {0,0,0,0};

   /*********/
   /* begin */
   /*********/

   if (Debug)
      fprintf (stdout, "PostAddAddress() |%s| %d\n", Address, CourtesyCopy);

   if (CourtesyCopy)
   {
      if (strsame (CgiFormCc, CcSelf, -1))
      {
         Address = SelfAddress;
         strcpy (SelfAddress, CgiRemoteUser);
      }
      SendUserNameItem[1].buf_addr = &CcType;
   }
   else
      SendUserNameItem[1].buf_addr = &ToType;

   if (SendOkCount || SendFailedCount)
      fprintf (HttpOut, "</PRE>%s<PRE>", Address);
   else
      fprintf (HttpOut, "%s<PRE>", Address);
   fflush (HttpOut);

   for (cptr = Address; *cptr && *cptr != '@' && *cptr != '%'; cptr++);
   if (*cptr == '@' && cptr > Address)
   {
      /*******************************/
      /* RFC821-style address (SMTP) */
      /*******************************/

      if (!SmtpTransport[0])
      {
         SendFailedCount++;
         fprintf (HttpOut, "%%%s-E-SMTP, not available.\n", Utility);
         return (SS$_NORMAL);
      }

      sptr = String;
      strcpy (sptr, SmtpTransport);
      while (*sptr) sptr++;
      *sptr++ = '%';
      *sptr++ = '\"';
      /* skip leading spaces */
      for (cptr = Address; isspace(*cptr); cptr++);
      while (*cptr) *sptr++ = *cptr++;
      /* trim trailing spaces */
      while (isspace(sptr[-1])) sptr--;
      *sptr++ = '\"';
      *sptr = '\0';
      SendUserNameItem[0].buf_addr = String;
      SendUserNameItem[0].buf_len = sptr - String;
   }
   else
   if (*cptr == '%')
   {
      /***************************/
      /* mail transport involved */
      /***************************/

      SendFailedCount++;
      fprintf (HttpOut, "%%%s-E-TRANS, mail transports not supported\n",
               Utility);
      return (SS$_NORMAL);
   }
   else
   {
      /*******************/
      /* vanilla address */
      /*******************/

      SendUserNameItem[0].buf_addr = Address;
      SendUserNameItem[0].buf_len = strlen(Address);
   }

   if (Debug)
      fprintf (stdout, "address |%s|\n", SendUserNameItem[0].buf_addr);
   status = mail$send_add_address (SendContextPtr, &SendUserNameItem,
                                   &NullItem);
   if (Debug) fprintf (stdout, "mail$send_add_address() %%X%08.08X\n", status);

   if (VMSok (status))
   {
      if (CourtesyCopy)
         fprintf (HttpOut, "<I>ok (CC:)</I>");
      else
         fprintf (HttpOut, "<I>ok</I>");
      SendOkCount++;
   }
   else
      SendFailedCount++;

   return (status);
}

/*****************************************************************************/
/*
*/ 

int GetJpiUserName ()

{
   register char  *cptr, *sptr;

   int  status;
   unsigned long  Pid = 0;
   struct {
      short int  buf_len;
      short int  item;
      unsigned char   *buf_addr;
      unsigned short  *ret_len;
   }
   JpiUserNameItem [] =
   {
      { sizeof(PaddedJpiUserName)-1, JPI$_USERNAME, PaddedJpiUserName, 0 },
      {0,0,0,0}
   };

   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "GetJpiUserName()\n");

   if (VMSnok (status = sys$getjpiw (0, &Pid, 0, &JpiUserNameItem, 0, 0, 0)))
   {
      fprintf (stdout, "%%%s-I-WHERE, %s %d\n", Utility, __FILE__, __LINE__);
      exit (status);
   }
   PaddedJpiUserName[12] = '\0';
   if (Debug) fprintf (stdout, "PaddedJpiUserName |%s|\n", PaddedJpiUserName);
   sptr = JpiUserName;
   for (cptr = PaddedJpiUserName; *cptr && !isspace(*cptr); cptr++);
   *sptr = '\0';
   if (Debug) fprintf (stdout, "JpiUserName |%s|\n", JpiUserName);
}

/*****************************************************************************/
/*
Assume the identity of the mild-mannered user.  Creates a space-padded 12 
character string containing the username.  Calls a macro routine to copy this 
name into the process header (requires CMKRNL).  Effectively the process 
becomes identified by the string.  Used by PostMessage() to masquerade as the
sender of the message.  SYSPRV with MAIL$_SEND_FROM_LINE is fine until a
foreign mail transport is invoked (e.g. MX) and then ceases to work!  This
kludge becomes necessary!
*/ 

TelephoneBooth (char *UserName)

{
   register int  len;
   register char  *cptr, *sptr;

   int  status;
   char  PaddedUserName [13];

   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "TelephoneBooth() |%s|\n", UserName);

   if (!AuthenticatedSender) return;

   sptr = PaddedUserName;
   len = sizeof(PaddedUserName)-1;
   for (cptr = UserName; *cptr && len--; *sptr++ = *cptr++);
   if (len < 0)
   {
      ErrorGeneral (ErrorStringSize, __FILE__, __LINE__);
      exit (SS$_NORMAL);
   }
   while (len-- > 0) *sptr++ = ' ';
   *sptr = '\0';
   if (Debug) fprintf (stdout, "|%s|\n", PaddedUserName);

   /* ensure the username is changed back upon exit */
   ExitHandler.HandlerAddress = &ExitViaTelephoneBooth;
   ExitHandler.ArgCount = 1;
   ExitHandler.ExitStatus = &ExitStatus;
   if (VMSnok (status = sys$dclexh (&ExitHandler)))
   {
      fprintf (stdout, "%%%s-I-WHERE, %s %d\n", Utility, __FILE__, __LINE__);
      exit (status);
   }

   if (VMSnok (status = SetUserName (PaddedUserName)))
   {
      fprintf (stdout, "%%%s-I-WHERE, %s %d\n", Utility, __FILE__, __LINE__);
      exit (status);
   }
}

/*****************************************************************************/
/*
A VMS exit handler.  When the images exit (normal or error) ensure the assumed
username is changed back.
*/ 

ExitViaTelephoneBooth ()

{
   if (Debug)
      fprintf (stdout, "ExitViaTelephoneBooth()\n %%X%08.08X", ExitStatus);

   if (!AuthenticatedSender) return;
   SetUserName (PaddedJpiUserName);
}

/*****************************************************************************/
/*
This function fills the 'String' storage with up to 'SizeOfString'-1 
characters from the HTTP input stream until the storage fills or the delimiter 
is encountered.  If the delimitter is specified as the null character ('\0') 
the all of the reset of the data stream is placed into the 'String' storage.  
It returns 0 or greater as the length of the returned string.  If the 'String' 
storage is too small to completely receive the characters required the 
function returns 'SizeOfString' to indicate the overflow.  Uses the global 
storage 'ContentLength' (if non-zero) to check when the stream should 
terminate, keeping track of the number of characters processed in global 
storage 'ContentCount'.  Not designed to retrieve from binary data streams!
*/ 

int GetHttpString
(
char Delimiter,
char *String,
int SizeOfString,
boolean UrlEscaped
)
{
   static char  *HttpBufferPtr = NULL;
   static char  HttpBuffer [HttpBufferSize];

   register int  sleft, clen, ccnt;
   register char  c, del, fc;
   register char  *sptr, *hbptr;

   /*********/
   /* begin */
   /*********/

   if (Debug)
      fprintf (stdout,
               "GetHttpString() ContentLength/Count: %d/%d\n",
               ContentLength, ContentCount);

   if (HttpBufferPtr == NULL)
      *(hbptr = HttpBuffer) = '\0';
   else
      hbptr = HttpBufferPtr;

   /* put these into register storage for efficiency */
   clen = ContentLength;
   ccnt = ContentCount;
   del = Delimiter;
   sptr = String;
   sleft = SizeOfString - 1;

   while ((!del || *hbptr != del) && sleft && (!clen || ccnt < clen))
   {
      if (!*hbptr)
      {
         /* buffer empty (or first call), read from HTTP source */
         if (Debug) fprintf (stdout, "fgets()\n");
         if (fgets (HttpBuffer, sizeof(HttpBuffer), HttpIn) == NULL)
         {
            ErrorGeneral ("HTTP stream terminated unexpectedly.",
                          __FILE__, __LINE__);
            exit (SS$_NORMAL);
         }
         hbptr = HttpBuffer;
         if (Debug) fprintf (stdout, "HttpBuffer (%d) |%s|\n", __LINE__, hbptr);
         if (!strncmp (hbptr, "POST ", 5))
         {
            /* server providing header and body (pre-v4.3 behaviour), absorb */
            if (Debug) fprintf (stdout, "absorb HTTP header\n");
            for (;;)
            {
               if (fgets (HttpBuffer, sizeof(HttpBuffer), HttpIn) == NULL)
               {
                  ErrorGeneral ("HTTP stream terminated unexpectedly.",
                                __FILE__, __LINE__);
                  exit (SS$_NORMAL);
               }
               if (Debug)
                  fprintf (stdout, "HttpBuffer (%d) |%s|\n",
                           __LINE__, HttpBuffer);
               if (!HttpBuffer[0] || HttpBuffer[0] == '\n') break;
            }
            if (fgets (HttpBuffer, sizeof(HttpBuffer), HttpIn) == NULL)
            {
               ErrorGeneral ("HTTP stream terminated unexpectedly.",
                             __FILE__, __LINE__);
               exit (SS$_NORMAL);
            }
            hbptr = HttpBuffer;
            if (Debug)
               fprintf (stdout, "HttpBuffer (%d) |%s|\n",
                        __LINE__, HttpBuffer);
         }
         continue;
      }
      if (*hbptr == '\r' || *hbptr == '\n')
      {
         hbptr++;
         continue;
      }
      if (!UrlEscaped)
      {
         *sptr++ = *hbptr++;
         ccnt++;
         sleft--;
         continue;
      }
      if (*hbptr != '%')
      {
         /* not an escaped character */
         if (*hbptr == '+')
         {
            *sptr++ = ' ';
            hbptr++;
         }
         else
            *sptr++ = *hbptr++;
         ccnt++;
         sleft--;
         continue;
      }

      /* an escaped character ("%xx" where xx is a hex number) */
      hbptr++;
      if (!*hbptr)
      {
         /* buffer empty read from HTTP source */
         if (Debug) fprintf (stdout, "fgets()\n");
         if (fgets (HttpBuffer, sizeof(HttpBuffer), HttpIn) == NULL)
         {
            ErrorGeneral ("HTTP stream terminated unexpectedly.",
                          __FILE__, __LINE__);
            exit (SS$_NORMAL);
         }
         hbptr = HttpBuffer;
         if (Debug) fprintf (stdout, "HttpBuffer (%d) |%s|\n", __LINE__, hbptr);
      }
      ccnt++;
      c = 0;
      /* first hex digit */
      fc = *hbptr;
      if (fc >= '0' && fc <= '9')
         c = (fc - (int)'0') << 4;
      else
      if (toupper(fc) >= 'A' && toupper(fc) <= 'F')
         c = (toupper(fc) - (int)'A' + 10) << 4;
      else
      {
         /* not a valid hex digit, assume its a mistake! */
         *sptr++ = '%';
         continue;
      }
      if (fc) hbptr++;
      if (!*hbptr)
      {
         /* buffer empty read from HTTP source */
         if (Debug) fprintf (stdout, "fgets()\n");
         if (fgets (HttpBuffer, sizeof(HttpBuffer), HttpIn) == NULL)
         {
            ErrorGeneral ("HTTP stream terminated unexpectedly.",
                          __FILE__, __LINE__);
            exit (SS$_NORMAL);
         }
         hbptr = HttpBuffer;
         if (Debug) fprintf (stdout, "HttpBuffer (%d) |%s|\n", __LINE__, hbptr);
      }
      ccnt++;
      /* second hex digit */
      if (*hbptr >= '0' && *hbptr <= '9')
         c += (*hbptr - (int)'0');
      else
      if (toupper(*hbptr) >= 'A' && toupper(*hbptr) <= 'F')
         c += (toupper(*hbptr) - (int)'A' + 10);
      else
      {
         /* not a valid hex digit, assume its a bigger mistake! */
         *sptr++ = '%';
         *sptr++ = fc;
         continue;
      }
      if (*hbptr) hbptr++;
      *sptr++ = c;
      ccnt++;
      sleft--;
   }

   if (*hbptr == del)
   {
      /* if the loop exited due to a delimiter encountered, step over it */
      hbptr++;
      ccnt++;
   }

   *sptr = '\0';
   if (Debug) fprintf (stdout, "String |%s|\n", String);

   /* if we're using a 'ContentLength' then keep track of 'ContentCount' */
   if (clen)
      ContentCount = ccnt;
   else
      ContentCount = 0;

   HttpBufferPtr = hbptr;

   if (!sleft && *hbptr != del)
   {
      /* must have run out of string space, return overflow indication */
      return (SizeOfString);
   }
   else
      return (sptr - String);
}

/*****************************************************************************/
/*
*/

boolean GetCgiVariable
(
char *VariableName,
char *VariableValue,
int VariableValueSize
)
{
   static $DESCRIPTOR (VariableNameDsc, "");
   static $DESCRIPTOR (VariableValueDsc, "");

   register int  status;

   unsigned short  Length;

   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "GetCgiVariable() |%s|\n", VariableName);

   VariableNameDsc.dsc$w_length = strlen(VariableName);
   VariableNameDsc.dsc$a_pointer = VariableName;
   VariableValueDsc.dsc$w_length = VariableValueSize-1;
   VariableValueDsc.dsc$a_pointer = VariableValue;

   if (VMSok (status =
       lib$get_symbol (&VariableNameDsc, &VariableValueDsc, &Length, 0)))
      VariableValue[Length] = '\0';
   else
      VariableValue[0] = '\0';

   if (status == LIB$_NOSUCHSYM) return (false);
   if (VMSnok (status))
   {
      if (Debug) fprintf (stdout, "lib$get_symbol() %%X%08.08X\n", status);
      fprintf (stdout, "%%%s-I-WHERE, %s %d\n", Utility, __FILE__, __LINE__);
      exit (status);
   }
   if (Debug) fprintf (stdout, "|%s|\n", VariableValue);
   return (true);
}

/*****************************************************************************/
/*
Copy string from 'cptr' to 'sptr', escaping forbidden HTML characters.  A 
maximum of 'scnt'-1 characters are copied, with the resulting string always 
terminated.  The count of the number of characters copied is returned 
(excluding the terminating null).
*/ 

char* CopyToHtml
(
register char *sptr,
register char *cptr,
register int scnt
)
{
   register char  *StartPtr;

   if (scnt-- <= 0) return;
   StartPtr = sptr;
   while (*cptr && scnt--)
   {
      switch (*cptr)
      {
         case '\"' :
            if (scnt >= 6)
            {
               *sptr++ = '&'; *sptr++ = 'q'; *sptr++ = 'u'; *sptr++ = 'o'; 
               *sptr++ = 't'; *sptr++ = ';';
               scnt -= 6;
               cptr++;
            }
            break;
         case '<' :
            if (scnt >= 4)
            {
               *sptr++ = '&'; *sptr++ = 'l'; *sptr++ = 't'; *sptr++ = ';'; 
               scnt -= 4;
               cptr++;
            }
            break;
         case '>' :
            if (scnt >= 4)
            {
               *sptr++ = '&'; *sptr++ = 'g'; *sptr++ = 't'; *sptr++ = ';'; 
               scnt -= 4;
               cptr++;
            }
            break;
         case '&' :
            if (scnt >= 5)
            {
               *sptr++ = '&'; *sptr++ = 'a'; *sptr++ = 'm'; *sptr++ = 'p'; 
               *sptr++ = ';';
               scnt -= 5;
               cptr++;
            }
            break;
         default :
            *sptr++ = *cptr++;
            scnt--;
      }
   }
   *sptr = '\0';
   return (sptr - StartPtr);
}

/*****************************************************************************/
/*
*/

ErrorAuthentication
(
char *SourceFileName,
int SourceLineNumber
)
{
   register char  *cptr;

   /*********/
   /* begin */
   /*********/

   /* 
      The source file format provided by the "__FILE__" macro will be
      "device:[directory]name.type;ver".  Reduce that to "name.type".
   */
   for (cptr = SourceFileName; *cptr && *cptr != ';'; cptr++);
   if (*cptr)
   {
      while (*cptr != '.') cptr--;
      *cptr-- = '\0';
   }
   while (*cptr != ']') cptr--;
   cptr++;

   fprintf (HttpOut,
"HTTP/1.0 401 Authentication failure.\n\
WWW-Authenticate: Basic realm=\"HFRD\"\n\
Content-Type: text/html\n\
\n\
<!-- SoftwareID: %s Module: %s Line: %d -->\n\
<H1>ERROR!</H1>\n\
<P>Reported by server.\n\
<P>Authentication failure.\n",
   SoftwareID, cptr, SourceLineNumber);
}

/*****************************************************************************/
/*
*/

ErrorGeneral
(
char *Text,
char *SourceFileName,
int SourceLineNumber
)
{
   register char  *cptr;

   /*********/
   /* begin */
   /*********/

   /* 
      The source file format provided by the "__FILE__" macro will be
      "device:[directory]name.type;ver".  Reduce that to "name.type".
   */
   for (cptr = SourceFileName; *cptr && *cptr != ';'; cptr++);
   if (*cptr)
   {
      while (*cptr != '.') cptr--;
      *cptr-- = '\0';
   }
   while (*cptr != ']') cptr--;
   cptr++;

   if (!HttpHasBeenOutput) fputs (Http404Header, HttpOut);
   fprintf (HttpOut,
"<!-- SoftwareID: %s Module: %s Line: %d -->\n\
<H1>ERROR!</H1>\n\
<P>Reported by server.\n\
<P>%s\n",
   SoftwareID, cptr, SourceLineNumber, Text);
}

/*****************************************************************************/
/*
*/

ErrorVmsStatus
(
int StatusValue,
char *Text,
char *HiddenText,
char *SourceFileName,
int SourceLineNumber
)
{
   static char  Message [256];
   static $DESCRIPTOR (MessageDsc, Message);

   register char  *cptr;
   int  status;
   short int  Length;

   /*********/
   /* begin */
   /*********/

   if (VMSok (status = sys$getmsg (StatusValue, &Length, &MessageDsc, 1, 0))) 
   {
      Message[Length] = '\0';
      Message[0] = toupper(Message[0]);
   }
   else
      exit (status);

   /* 
      The source file format provided by the "__FILE__" macro will be
      "device:[directory]name.type;ver".  Reduce that to "name.type".
   */
   for (cptr = SourceFileName; *cptr && *cptr != ';'; cptr++);
   if (*cptr)
   {
      while (*cptr != '.') cptr--;
      *cptr-- = '\0';
   }
   while (*cptr != ']') cptr--;
   cptr++;

   if (!HttpHasBeenOutput) fputs (Http404Header, HttpOut);
   fprintf (HttpOut,
"<!-- SoftwareID: %s Module: %s Line: %d -->\n\
<H1>ERROR!</H1>\n\
<P>Reported by server.\n\
<P>%s ... <TT>%s</TT>\n\
<!-- %%X%08.08X \"%s\" -->\n",
   SoftwareID, cptr, SourceLineNumber, Message, Text, StatusValue, HiddenText);
}

/****************************************************************************/
/*
Does a case-insensitive, character-by-character string compare and returns 
true if two strings are the same, or false if not.  If a maximum number of 
characters are specified only those will be compared, if the entire strings 
should be compared then specify the number of characters as 0.
*/ 

boolean strsame
(
register char *sptr1,
register char *sptr2,
register int  count
)
{
   while (*sptr1 && *sptr2)
   {
      if (toupper (*sptr1++) != toupper (*sptr2++)) return (false);
      if (count)
         if (!--count) return (true);
   }
   if (*sptr1 || *sptr2)
      return (false);
   else
      return (true);
}

/*****************************************************************************/

